	name	RotorDum
	title	Dummy RotorDRV TSR
;
;  This program is a minimal stupid RotorDRV TSR.
;  Instead of moving antennas, it does nothing.
;

_TEXT	segment word public 'CODE'

	ORG	100h			; this is a .COM file!

	assume	cs:_TEXT, ds:_TEXT, es:_TEXT, ss:_TEXT

start:	jmp	install

enabled	db	1		; enabled=1, disabled=0
azim	dw	0		; save target az and el
elev	dw	0


;******************************************************************
;  Here is the interrupt service routine.
;******************************************************************

	assume	ds:nothing, es:nothing, ss:nothing

isr:	jmp	dispatch

	ORG	isr + 10
	DB	"RotorDRV"	; signature string

dispatch proc	near
	sti
	cmp	ah,0		; dispatch according to function code
	je	readstat
	cmp	ah,3
	je	readpos
	cmp	ah,4
	je	settarg
	cmp	ah,9
	je	enable
	iret
dispatch endp

readstat proc	near
	mov	al,0		; status is always good.
	iret
readstat endp

readpos	proc	near
	mov	ax,cs:elev
	mov	cx,ax
	mov	bx,cs:azim
	mov	dx,bx
	iret
readpos	endp

;******************************************************************
; Function 04: Set Target position
; --------------------------------
; This function is used by the TSR to tell the tracker TSR where to
; point the antennas.  It is called periodically.
;
;    At Entry: AH=4
;              CX - target ELEV value in degrees (-90 to 269, signed binary)
;              DX - target AZIM value in degrees (0-359, binary)
;              Note: If either value is invalid the entire command will
;                    be ignored.
;
;    At Exit:  No parameters are returned
;*******************************************************************
; 123456789
; +000 +000
;  az   el

settarg	proc	near
	cmp	enabled,0	; don't do anything if disabled.
	je	st_exit

	mov	cs:azim,dx
	mov	cs:elev,cx

st_exit:	iret
settarg endp

enable	proc	near
	mov	enabled,al	; save the enable/disable flag.
	iret
enable	endp

lastbyte	equ	this byte	; flag for end of memory used

install	proc	near

	mov	dx, offset isr	; get address of service routine
	mov	ax, 2563h	; set vector 0x63
	int	21h		; set up the interrupt vector

				; reserve memory and terminate.
	mov	dx,offset lastbyte	; get last address used
	add	dx,15		; round up
	mov	cl,4
	shr	dx,cl		; convert to paragraphs
	mov	ax,3100h	; TSR function code, good status
	int	21H		; go TSR!

install	endp

_TEXT	ends

	end	start
